gtkmm: Gtk::SizeGroup Class Reference

gtkmm 4.23.2

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::SizeGroup Class Reference

Gtk::SizeGroup provides a mechanism for grouping a number of widgets together so they all request the same amount of space. More...

`#include <gtkmm/sizegroup.h>`

Inheritance diagram for Gtk::SizeGroup:
[legend]

## Public Types
enum class | Mode { Mode::NONE , Mode::HORIZONTAL , Mode::VERTICAL , Mode::BOTH }
| The mode of the size group determines the directions in which the size group affects the requested sizes of its component widgets. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| SizeGroup (SizeGroup && src) noexcept
SizeGroup & | operator= (SizeGroup && src) noexcept
| ~SizeGroup () noexcept override
GtkSizeGroup * | gobj ()
| Provides access to the underlying C GObject.
const GtkSizeGroup * | gobj () const
| Provides access to the underlying C GObject.
GtkSizeGroup * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
void | set_mode (Mode mode)
| Sets the Gtk::SizeGroup::Mode of the size group.
Mode | get_mode () const
| Gets the current mode of the size group.
void | add_widget (Widget & widget)
| Adds a widget to a Gtk::SizeGroup.
void | remove_widget (Widget & widget)
| Removes a widget from a Gtk::SizeGroup.
std::vector< Widget * > | get_widgets ()
| Returns the list of widgets associated with size_group.
std::vector< const Widget * > | get_widgets () const
| Returns the list of widgets associated with size_group.
Glib::PropertyProxy< Mode > | property_mode ()
| The direction in which the size group affects requested sizes.
Glib::PropertyProxy_ReadOnly< Mode > | property_mode () const
| The direction in which the size group affects requested sizes.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SizeGroup > | create (Mode mode)
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| SizeGroup (Mode mode)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::SizeGroup > | wrap (GtkSizeGroup * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Gtk::SizeGroup provides a mechanism for grouping a number of widgets together so they all request the same amount of space.

This is typically useful when you want a column of widgets to have the same size, but you can't use a Gtk::Grid widget.

In detail, the size requested for each widget in a Gtk::SizeGroup is the maximum of the sizes that would have been requested for each widget in the size group if they were not in the size group. The mode of the size group (see set_mode()) determines whether this applies to the horizontal size, the vertical size, or both sizes.

Note that size groups only affect the amount of space requested, not the size that the widgets finally receive. If you want the widgets in a GtkSizeGroup to actually be the same size, you need to pack them in such a way that they get the size they request and not more. For example, if you are packing your widgets into a table, you would not include the Gtk::FILL flag.

Widgets can be part of multiple size groups; GTK+ will compute the horizontal size of a widget from the horizontal requisition of all widgets that can be reached from the widget by a chain of size groups of type Gtk::SizeGroup::Mode::HORIZONTAL or Gtk::SizeGroup::Mode::BOTH, and the vertical size from the vertical requisition of all widgets that can be reached from the widget by a chain of size groups of type Gtk::SizeGroup::Mode::VERTICAL or Gtk::SizeGroup::Mode::BOTH.

## Constructor & Destructor Documentation

## ◆ SizeGroup() [1/2]

Gtk::SizeGroup::SizeGroup | ( | SizeGroup && | src | ) |
| noexcept

## ◆ ~SizeGroup()

Gtk::SizeGroup::~SizeGroup | ( |  | ) |
| overridenoexcept

## ◆ SizeGroup() [2/2]

Gtk::SizeGroup::SizeGroup | ( | Mode | mode | ) |
| explicitprotected

## Member Function Documentation

## ◆ add_widget()

void Gtk::SizeGroup::add_widget | ( | Widget & | widget | ) |

Adds a widget to a Gtk::SizeGroup.

In the future, the requisition of the widget will be determined as the maximum of its requisition and the requisition of the other widgets in the size group. Whether this applies horizontally, vertically, or in both directions depends on the mode of the size group. See set_mode().

When the widget is destroyed or no longer referenced elsewhere, it will be removed from the size group.

Parameters

  widget | The Gtk::Widget to add.

## ◆ create()

Glib::RefPtr< SizeGroup > Gtk::SizeGroup::create | ( | Mode | mode | ) |
| static

## ◆ get_mode()

Mode Gtk::SizeGroup::get_mode | ( |  | ) | const

Gets the current mode of the size group.

Returns
  The current mode of the size group.

## ◆ get_type()

GType Gtk::SizeGroup::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_widgets() [1/2]

std::vector< Widget * > Gtk::SizeGroup::get_widgets | ( |  | ) |

Returns the list of widgets associated with size_group.

Returns
  A SList of widgets. The list is owned by GTK and should not be modified.

## ◆ get_widgets() [2/2]

std::vector< const Widget * > Gtk::SizeGroup::get_widgets | ( |  | ) | const

Returns the list of widgets associated with size_group.

Returns
  A SList of widgets. The list is owned by GTK and should not be modified.

## ◆ gobj() [1/2]

GtkSizeGroup * Gtk::SizeGroup::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkSizeGroup * Gtk::SizeGroup::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkSizeGroup * Gtk::SizeGroup::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

SizeGroup & Gtk::SizeGroup::operator= | ( | SizeGroup && | src | ) |
| noexcept

## ◆ property_mode() [1/2]

Glib::PropertyProxy< Mode > Gtk::SizeGroup::property_mode | ( |  | ) |

The direction in which the size group affects requested sizes.

Default value: Gtk::SizeGroup::Mode::HORIZONTAL

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_mode() [2/2]

Glib::PropertyProxy_ReadOnly< Mode > Gtk::SizeGroup::property_mode | ( |  | ) | const

The direction in which the size group affects requested sizes.

Default value: Gtk::SizeGroup::Mode::HORIZONTAL

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove_widget()

void Gtk::SizeGroup::remove_widget | ( | Widget & | widget | ) |

Removes a widget from a Gtk::SizeGroup.

Parameters

  widget | The Gtk::Widget to remove.

## ◆ set_mode()

void Gtk::SizeGroup::set_mode | ( | Mode | mode | ) |

Sets the Gtk::SizeGroup::Mode of the size group.

The mode of the size group determines whether the widgets in the size group should all have the same horizontal requisition (Gtk::SizeGroup::Mode::HORIZONTAL) all have the same vertical requisition (Gtk::SizeGroup::Mode::VERTICAL), or should all have the same requisition in both directions (Gtk::SizeGroup::Mode::BOTH).

Parameters

  mode | The mode to set for the size group.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::SizeGroup > wrap | ( | GtkSizeGroup * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.